//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

// C Source File
// Created 18/07/2005; 19:04:47

#include <tigcclib.h>

#include "lines.h"

//---------------------------------------------------------------------------

extern char * Plane0;

//-----------------------------------------------------------------------------

int clipping_enable=1;

//-----------------------------------------------------------------------------

void DrawLineFastC (int x1, int y1, int x2, int y2)
{
	
	
	// final points
	
	int xx1=x1;
	int yy1=y1;
	int xx2=x2;
	int yy2=y2;
	
	// visible points
	
	int v1 = (x1>=0 && x1<=159 && y1>=0 && y1<=99);
	int v2 = (x2>=0 && x2<=159 && y2>=0 && y2<=99);
	
	if ((!clipping_enable) && !(v1 && v2))
	return;
	
	// if line not completely visible
	
	if (!(v1 && v2))
	{
		
		// equation of line (x1,y1,x2,y2) :
		// (x-x1) * (y2-y1) - (y-y1) * (x2-x1) = 0
		
		// sort(1,2) -> (x1 <= x2)
		if (x1>x2)
		{
			int x,y,v;
			x=x1;y=y1;x1=x2;y1=y2;x2=x;y2=y;
			x=xx1;y=yy1;xx1=xx2;yy1=yy2;xx2=x;yy2=y;
			v=v1;v1=v2;v2=v;
		}
		
		// border : LEFT
		if (v1==0 && x1<0 && x2>=0)
		{
			long d = (0-x1) * (y2-y1) / (x2-x1) + y1;
			if (d>=0 && d<=99)
			{xx1=0;yy1=d;v1=1;}
		}
		
		// border : RIGHT
		if (v2==0 && x1<=159 && x2>159)
		{
			long d = (159-x1) * (y2-y1) / (x2-x1) + y1;
			if (d>=0 && d<=99)
			{xx2=159;yy2=d;v2=1;}
		}
		
		// sort(1,2) -> (y1 <= y2)
		if (y1>y2)
		{
			int x,y,v;
			x=x1;y=y1;x1=x2;y1=y2;x2=x;y2=y;
			x=xx1;y=yy1;xx1=xx2;yy1=yy2;xx2=x;yy2=y;
			v=v1;v1=v2;v2=v;
		}
		
		// border : UP
		if (v1==0 && y1<0 && y2>=0)
		{
			long d = (0-y1) * (x2-x1) / (y2-y1) + x1;
			if (d>=0 && d<=159)
			{xx1=d;yy1=0;v1=1;}
		}
		
		// border : DOWN
		if (v2==0 && y1<=99 && y2>99)
		{
			long d = (99-y1) * (x2-x1) / (y2-y1) + x1;
			if (d>=0 && d<=159)
			{xx2=d;yy2=99;v2=1;}
		}
		
	}
	
	// draw final line
	
	if (v1 && v2)
	DrawLineFast(xx1,yy1,xx2,yy2);
}

//---------------------------------------------------------------------------

void DrawLineFast (int x1, int y1, int x2, int y2)
{
	
	int x = x1;
	int y = y1;
	int dx = (x2-x1);
	int dy = (y2-y1);
	
	int mov = 0;
	
	char *ptr = Plane0 + (y<<5) - (y<<1) + (x>>3);
	short mask = (0x80 >> (x&7)); // 'short' type for shift sign bit
	
	if (abs(dx) > abs(dy))
	{
		for (;;)
		{
			//if (x>=0 && x<=159 && y>=0 && y<=99) // CLIPPING
			*ptr |= (char)mask;
			
			if (x==x2)
			break;
			
			if (x1<x2)
			{ x++; mask >>= 1; if ((x&7)==0) { mask=0x80; ptr++; } }
			else
			{ x--; mask <<= 1; if ((x&7)==7) { mask=0x01; ptr--; } }
			
			mov += (abs(dy)+1);
			
			if (mov >= (abs(dx)+1))
			{
				
				if (y1<y2)
				{ y++; ptr+=30; }
				else
				{ y--; ptr-=30; }
				
				
				mov -= (abs(dx)+1);
			}
		}
	}
	else
	{
		for (;;)
		{
			//if (x>=0 && x<=159 && y>=0 && y<=99) // CLIPPING
			*ptr |= (char)mask;
			
			if (y==y2)
			break;
			
			if (y1<y2)
			{ y++; ptr+=30; }
			else
			{ y--; ptr-=30; }
			
			mov += (abs(dx)+1);
			
			if (mov >= (abs(dy)+1))
			{
				
				if (x1<x2)
				{ x++; mask >>= 1; if ((x&7)==0) { mask=0x80; ptr++; } }
				else
				{ x--; mask <<= 1; if ((x&7)==7) { mask=0x01; ptr--; } }
				
				
				mov -= (abs(dy)+1);
			}
		}
	}
	
	
	
}
//---------------------------------------------------------------------------
