//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

#define BLOCK_WIDTH (32)
#define BLOCK_LENGTH (64)
#define BLOCK_HEIGHT (16)

// BLOCK_SHOWN < BLOCK_MAX
#define BLOCK_MAX (10)
#define BLOCK_SHOWN (6)

#define SPEED_MAX (16)

#define SHOW_LIAISONS (0x01)
#define SHOW_BORDERS  (0x02)

//---------------------------------------------------------------------------

enum {CT_NORMAL,CT_INTOSHIP,CT_SKY1,CT_SKY2,CT_SIDE,CT_BACKSKY,CT_MAX};

//---------------------------------------------------------------------------

typedef struct
{
	TVertex P[4];
}
TLiaison;

typedef struct
{
	byte ay; // block global angle
	char ay_diff; // block local angle
	
	TLiaison L[3];
}
TBlock;

typedef struct
{
	TBlock B[BLOCK_MAX];
	int blocks_count;
}
TTunnelData;

typedef struct
{
	
	TObject OTunnel;
	TObject OShip;
	TObject OCamera;
	
	TTunnelData TunnelD;
	TVertex VShip[3]; // [x] = ship_numpoints
	
	TMotionData MDShip;
	
	int CameraType;
	int ShipBlockID;
	int ShipSpeed;
	int show_type;
	
}
TGame;


//---------------------------------------------------------------------------

void NewGame(void);

void Tunnel_Init(void);
void Ship_Init(void);

void BlockAdd(char ay_diff);
void BlockAddRandom(void);
int Block_IsPositionInside(TBlock*BlockPtr,TPoint3D*P);

void Ship_TickLCD(void);
void Ship_OnNewAngle(void);

void TranslateAll(void);

void Camera_Place(void);

void DrawScreen(void);
void DrawTunnel(void);
void DrawShip(void);


//---------------------------------------------------------------------------


