//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

// C Source File
// Created 29/06/2005; 21:41:18

//-----------------------------------------------------------------------------
// MOVELINE FUNCTIONS
//-----------------------------------------------------------------------------

#include <tigcclib.h>

#include "motion.h"

//-----------------------------------------------------------------------------

void MD_MoveOnePixel (TMotionData *MD)
{
	
	// LOAD DATA
	
	int dx = MD->dx;
	int dy = MD->dy;
	
	int x=MD->x;
	int y=MD->y;
	
	int sc=MD->slope_counter;
	
	// PROCESS
	
	if (dx==0 && dy==0)
	return;
	
	if (abs(dx) > abs(dy))
	{
		
		(dx>0) ? x++ : x-- ;
		
		sc += abs(dy);
		
		if (sc >= abs(dx))
		{
			(dy>0) ? y++ : y-- ;
			sc -= abs(dx);
		}
		
	}
	else
	{
		
		(dy>0) ? y++ : y-- ;
		
		sc += abs(dx);
		
		if (sc >= abs(dy))
		{
			(dx>0) ? x++ : x-- ;
			sc -= abs(dy);
		}
		
	}
	
	// SAVE DATA
	
	MD->x=x;
	MD->y=y;
	
	MD->slope_counter=sc;
	
}
//---------------------------------------------------------------------------

void MD_OnNewSlope(TMotionData *MD)
{
	
	MD->slope_counter = 0;
	
}
//---------------------------------------------------------------------------

